mod Mtesting10

incl Maux10

rem 
  \para \bf  Pomocné definície pre testovanie  \end 

appldisp/0 Tex0_type_m
  Op('',0)

appldisp/3 Tex3_ok
  Prefix(70,0,Id(4,'OK',0),
         Fenced(Op('(',0),
                Infix(Arg(0),30,0,Subsup(Op('=',0),75,Arg(2),None),Arg(1)),Op(')',0)))

appldisp/3 Tex3_failed
  Prefix(70,0,Id(6,'FAILED',0),
         Fenced(Op('(',0),
                Infix(Arg(0),30,0,Subsup(Op(Ent('ne'),0),75,Arg(2),None),Arg(1)),
                Op(')',0)))

appldisp/2 Tex2_error_
  Prefix(70,0,Prefix(20,0,Id(6,'FAILED',0),Arg(0)),Fenced(Op('[',0),Arg(1),Op(']',0)))

appldisp/2 Tex2_test_case
  Fenced(Op('{',0),
         Infix(Prefix(70,2,Id(0,'Testing on  ',0),Arg(0)),20,0,Op(': ',0),Arg(1)),
         Op('}',0))

appldisp/3 Tex3_test_case
  Fenced(Op('{',0),
         Infix(Prefix(70,2,Id(0,'Testing on  ',0),Arg(0)),20,0,Op(': ',0),
               Infix(Arg(1),30,0,Op('; ',0),Arg(2))),Op('}',0))

appldisp/4 Tex4_test_case
  Fenced(Op('{',0),
         Infix(Prefix(70,2,Id(0,'Testing on  ',0),Arg(0)),20,0,Op(': ',0),
               Infix(Arg(1),30,0,Op('; ',0),Infix(Arg(2),30,0,Op('; ',0),Arg(3)))),
         Op('}',0))

appldisp/2 Tex2_check
  Infix(Arg(0),30,0,Subsup(Op('=',0),75,None,Id(6,'?',0)),Arg(1))

fun/0 Type_m 'Tex0_type_m'
  Type_m = 0,0

pred Type 
  Type(Type_m)

fun/3 Result_ok 'Tex3_ok'
  Result_ok(x,y,t) = 0,x,y,t

fun/3 Result_failed 'Tex3_failed'
  Result_failed(x,y,t) = 1,x,y,t

fun/2 Error_ 'Tex2_error_'
  Error_(msg,x) = 55,msg,x

pred Is_error_ 
  Is_error_ Error_(msg,x)

fun/2 Test_case2 'Tex2_test_case'
  Test_case2(t,rs) = 82,t,rs

fun/3 Test_case3 'Tex3_test_case'
  Test_case3(t,a,b) = 83,t,a,b

fun/4 Test_case4 'Tex4_test_case'
  Test_case4(t,a,b,c) = 84,t,a,b,c

fun/2 Check 'Tex2_check'
  Check(x,y) = Result_ok(x,y,Type_m) <- x = y
  Check(x,y) = Result_failed(x,y,Type_m) <- x != y

pred Result 
  Result Result_ok(x,y,t) <- M(x) & M(y) & Type(t)
  Result Result_failed(x,y,t) <- M(x) & M(y) & Type(t)

pred Results 
  Results(0)
  Results(r,rs) <- Result(r) & Results(rs)

fun Ct_ 'Tex1_ct'
  Ct_(n) = 1,n

fun Vt_ 'Tex1_vt'
  Vt_(i) = 0,i

fun/2 At_ 'Tex2_at'
  At_(t1,t2) = 2,t1,t2

fun/2 Mt_ 'Tex2_mt'
  Mt_(t1,t2) = 3,t1,t2

fun/2 St_ 'Tex2_st'
  St_(t1,t2) = 4,t1,t2

fun/3 Dt_ 'Tex3_dt'
  Dt_(t1,t2,t3) = 5,t1,t2,t3

pred Term_ 
  Term_ Ct_(n) <- N(n)
  Term_ Vt_(i) <- N(i)
  Term_ At_(t1,t2) <- Term_(t1) & Term_(t2)
  Term_ Mt_(t1,t2) <- Term_(t1) & Term_(t2)
  Term_ St_(t1,t2) <- Term_(t1) & Term_(t2)
  Term_ Dt_(t1,t2,t3) <- Term_(t1) & Term_(t2) & Term_(t3)
  Term_ Error_(msg,t1) <- Str(msg) & Term_(t1)

pred Results_term 
  Results_term(0)
  Results_term(Result_ok(x,y,t),rs) <- 
    Term_(x) & Term_(y) & Type(t) & Results_term(rs)
  Results_term(Result_failed(x,y,t),rs) <- 
    Term_(x) & Term_(y) & Type(t) & Results_term(rs)

fun Pushi_ 'Tex1_ci'
  Pushi_(n) = 1,n

fun Loadi_ 'Tex1_vi'
  Loadi_(i) = 0,i

fun/0 Addi_ 'Tex0_ai'
  Addi_ = 2,0

fun/0 Muli_ 'Tex0_mi'
  Muli_ = 3,0

fun/0 Subi_ 'Tex0_si'
  Subi_ = 4,0

fun Jzi_ 'Tex0_jzi'
  Jzi_(n) = 5,n

pred Instr_ 
  Instr_ Pushi_(n) <- N(n)
  Instr_ Loadi_(i) <- N(i)
  Instr_(Addi_)
  Instr_(Muli_)
  Instr_(Subi_)
  Instr_ Jzi_(n) <- N(n)

pred Program_ 
  Program_(0)
  Program_(i,is) <- Instr_(i) & Program_(is)

pred Results_program 
  Results_program(0)
  Results_program(Result_ok(x,y,t),rs) <- 
    Program_(x) & Program_(y) & Type(t) & Results_program(rs)
  Results_program(Result_failed(x,y,t),rs) <- 
    Program_(x) & Program_(y) & Type(t) & Results_program(rs)

pred Results_den 
  Results_den(0)
  Results_den(Test_case2(t,denr),rs) <- 
    Term_(t) & Result(denr) & Results_den(rs)

pred Results_run 
  Results_run(0)
  Results_run(Test_case2(p,runr),rs) <- 
    Program_(p) & Result(runr) & Results_run(rs)

pred Results_comp 
  Results_comp(0)
  Results_comp(Test_case3(t,p,rundenr),rs) <- 
    Term_(t) & Program_(p) & Result(rundenr) & Results_comp(rs)

pred Results_decomp 
  Results_decomp(0)
  Results_decomp(Test_case2((p,t),denrunr),rs) <- 
    Program_(p) & Term_(t) & Result(denrunr) & Results_decomp(rs)

rem 
  \para \bf  \it  Testovacie ohodnotenia  \end  \end 

fun/0 Primes100 
  Primes100 = 
  101,103,107,109,113,127,131,137,139,149,151,157,163,167,173,179,181,191,193,
  197,199,0

fun/0 Valuations 
  Valuations = Primes100,(0,Primes100),(256,Primes100),(256,0,Primes100),0

rem 
  \para \bf  \it  Testovacie zoznamy výrazov  \end  \end 

fun/0 Simple_terms 
  Simple_terms = Ct(7),Vt(2),At(Vt(0),Vt(1)),Mt(Vt(0),Vt(1)),0

fun/0 Complex_terms 
  Complex_terms = Term1,Term2,Term3,Term4,Term5,Term6,Term7,0

